/* ===========================================================================
                   Backtracking: N QUEENS
From: E.W. Dijkstra: 'A Short Introduction to the Art of Programming'.
      EWD 316 August 1971.
============================================================================ */
#include <iostream.h>
const int N=16; const int N2=32; // N should be >=1.     N2 = 2*N.
// N is the maximum number of queens for which the program works.
int nqueens, nq, nqueens1;
int  x    [N];    // array [0..N-1] of integer.
bool col  [N];    // array [0..N-1] of booleans.
bool up   [N2-1]; // array [0..2(N-1)] of booleans.
/*----------------------------------------------------------------------------
In Dijkstra: up is an array [-(N-1)..N-1] of booleans. We have indicated the
indexes he used in the comments: // up[...]. We had to increase his indexes by
nquees1, which is nqueens-1.
--------------------------------------------------------------------------- */
bool down [N2-1];                   // array [0..2(N-1)] of boolean.

void printar(int A[], int size)
{for (int i=0; i<size; i=i+1) {cout << A[i] << " ";}}

void generate()
{int h=0;
do {if (col[h] && up[nq-h+nqueens1] && down[nq+h])      // up[nq-h]
       {x[nq]=h; col[h]=false; up[nq-h+nqueens1]=false; // up[nq-h]
        down[nq+h]=false; nq=nq+1;
        if (nq==nqueens) {printar(x,nqueens); cout<<"\n";}
                         else generate();
        nq=nq-1;col[h]=true; up[nq-h+nqueens1]=true;    // up[nq-h]
        down[nq+h]=true;};
  h=h+1;}
while  (h!=nqueens);}
//----------------------------------------------------------------------------
void main()
{cout << "Type the number of queens (1 <= nqueens <= 16) and CR:\n";
cin >> nqueens; nq=0;
nqueens1=nqueens-1;             // Dijkstra does not need nqueens1
int k=0;
do {col[k]=true; k=k+1;} while (k!=nqueens);
k=0;
do {up[k]=true; down[k]=true; k=k+1;}           // up[k-nqueens+1]
while (k!=2*nqueens-1);
generate();
}
/* input:  output:
------------------------------------------------------------------------------
           Type the number of queens (1 <= nqueens <= 16) and CR:
   6 CR
           1  3  5  0  2  4
           2  5  1  4  0  3
           3  0  4  1  5  2
           4  2  0  5  3  1
--------------------------------------------------------------------------- */